<?php

namespace PurchasingBundle\Repository;


use Psr\Log\LoggerInterface;
use PurchasingBundle\Entity\Transaction;
use Schema\SchemaEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;
use Utils\StaticUtil\LogUtils;
use WordBundle\Entity\Word;

/**
 * TransactionRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TransactionRepository extends SchemaEntityRepository {

    const DEFAULT_MAX_RESULTS = 10;


    /** @var LoggerInterface $logger */
    private $logger;

    /**
     * TransactionRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, Transaction::class);

        $this->logger = $logger;
    }

    /**
     * @param $paymentId
     * @return mixed|null
     */
    public function findByPaymentId ($paymentId) {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('t')
            ->from('PurchasingBundle:Transaction', 't')
            ->where('t.ppPaymentId = :paymentId')
            ->setParameter('paymentId', $paymentId)
        ;

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getQuery()->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get transaction by Payment ID: ".$paymentId, $exception);
        }

        return $result;
    }

    /**
     * @param int $page
     * @param null|string $suggest
     * @param int $maxResults
     * @param string $sort
     * @return array|\Doctrine\ORM\Tools\Pagination\Paginator
     */
    public function findAllPaginatedTransactions ($page=1, ?string $suggest, $maxResults=self::DEFAULT_MAX_RESULTS, $sort='DESC') {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('t')
            ->from('PurchasingBundle:Transaction', 't');

        if (!is_null($suggest)) {
            $qb->where('t.ppPaymentId LIKE :suggest')
                ->setParameter('suggest', '%'.$suggest.'%');
        }

        $qb->orderBy('t.id',$sort);

        $results = array();

        try {
            $query   = $qb->getQuery();
            $results = $this->paginate($query,$page,$maxResults);
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all transactions", $exception);
        }

        return $results;

    }

    /**
     * @param Word $word
     * @param int $page
     * @param null|string $suggest
     * @param int $maxResults
     * @param string $sort
     * @return array|\Doctrine\ORM\Tools\Pagination\Paginator
     */
    public function findAllPaginatedTransactionsByWord (Word &$word, $page=1, ?string $suggest, $maxResults=self::DEFAULT_MAX_RESULTS, $sort='DESC') {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('t')
            ->from('PurchasingBundle:Transaction', 't')
            ->where('t.word = :word')
            ->setParameter('word',$word)
        ;

        if (!is_null($suggest)) {
            $qb->where('t.ppPaymentId LIKE :suggest')
                ->setParameter('suggest', '%'.$suggest.'%');
        }

        $qb->orderBy('t.id',$sort);

        $results = array();

        try {
            $query   = $qb->getQuery();
            $results = $this->paginate($query,$page,$maxResults);
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all transactions by word: ".$word->getId(), $exception);
        }

        return $results;

    }

}
